set serveroutput on;
--	Temat 11  PL/SQL, wyzwalacze
--	1.	Utwrz wyzwalacz, ktry nie pozwoli 
--	usun rekordu z tabeli Emp.

	CREATE OR REPLACE TRIGGER A
	BEFORE DELETE
	ON emp
	BEGIN
      RAISE_APPLICATION_ERROR (
         num=> -20107,
         msg=> 'Nie wooolno');
	END A;
/
--	2.	Utwrz wyzwalacz, ktry przy wstawianiu lub modyfikowaniu 
--	danych w tabeli Emp sprawdzi czy nowe zarobki (wstawiane lub 
--	modyfikowane) s wiksze ni 1000. W przeciwnym przypadku 
--	wyzwalacz powinien zgosi bd i nie dopuci do wstawienia 
--	rekordu. Uwaga:  Ten sam efekt mona uzyska atwiej przy 
--	pomocy wizw spjnoci typu CHECK. Uyjmy wyzwalacza w celach 
--	treningowych.

	CREATE OR REPLACE TRIGGER B
	BEFORE 	INSERT OR
			UPDATE OF SAL
	ON emp
	FOR EACH ROW
	BEGIN
		if	:NEW.sal < 1000 THEN
			RAISE_APPLICATION_ERROR (
			num=> -20107,
			msg=> 'Za maao');
		END IF;
	END B;
/
--	3.	Utwrz tabel budzet:
--	
	DROP TABLE budzet;
  CREATE TABLE budzet (wartosc INT NOT NULL);
--	
--	W tabeli tej bdzie przechowywana czna warto wynagrodzenia 
--	wszystkich pracownikw. Tabela bdzie zawsze zawieraa jeden 
--	wiersz. Naley najpierw obliczy pocztkow warto zarobkw:
--	
  INSERT INTO budzet (wartosc)
  SELECT SUM(sal) FROM emp;
  /
--	
--	Utwrz wyzwalacz, ktry bdzie pilnowa, aby warto w tabeli 
--	budzet bya zawsze aktualna, a wic przy wszystkich operacjach 
--	aktualizujcych tabel emp (INSERT, UPDATE, DELETE), wyzwalacz 
--	bdzie aktualizowa wpis w tabeli budet
--	4.	Napisz jeden wyzwalacz, ktry:
--		Nie pozwoli usun pracownika, ktrego pensja jest wiksza od 0.
--		Nie pozwoli zmieni nazwiska pracownika.
--		Nie pozwoli wstawi pracownika, ktry ju istnieje 
--		(sprawdzajc po nazwisku).

create or replace
TRIGGER C
	BEFORE 	
      INSERT OR
			UPDATE OF ename OR
			UPDATE OF sal OR
      DELETE  
	ON emp
	FOR EACH ROW
  DECLARE
       maxc integer := 0;
	BEGIN

  CASE
    WHEN INSERTING THEN
    
      SELECT count(*) INTO maxc FROM emp where ename = :new.ename;
      if( maxc < 1 ) then
        DBMS_OUTPUT.PUT_LINE('Inserting');
        update budzet set wartosc = wartosc + :new.sal;
      else
      RAISE_APPLICATION_ERROR (
         num=> -20107,
         msg=> 'Duplikat');
      end if;
      
    WHEN UPDATING('ename') THEN
    
        RAISE_APPLICATION_ERROR (
           num=> -20107,
           msg=> 'Nie wooolno');
    
    WHEN UPDATING('sal') THEN
      update budzet set wartosc = wartosc + :new.sal - :old.sal;   
    WHEN DELETING THEN
    
      SELECT sal INTO maxc FROM emp where ename = :new.ename;
      if maxc < 1 then
        DBMS_OUTPUT.PUT_LINE('Deleting');   
      else
        RAISE_APPLICATION_ERROR (
           num=> -20107,
           msg=> 'Nie wooolno');
      end if;
      
  END CASE;

	END C;
/
/*
delete from emp where empno = 1;  -- nie wolno
/
insert into emp (empno,ename,sal) values (111,'zbignievv',10); -- za malo
/
insert into emp (empno,ename,sal) values (111,'KING',10000); -- duplikat
/
update emp set ename = 'aaa' where empno = 888; -- nie wolno
/
*/


--select wartosc from budzet;/  -- 29340
--insert into emp (empno,ename,sal) values (111,'ANDEJ',10000);/ -- ok?
select * from budzet;/  -- 39340

update emp set sal = 10000 where empno = 111; -- ok?

--	5.	Napisz wyzwalacz, ktry:
--		Nie pozwoli zmniejsza pensji.
--		Nie pozwoli usuwa pracownikw.
/
drop TRIGGER C;
/
set serveroutput on;
create or replace
TRIGGER D
	BEFORE 	
			UPDATE OF sal OR
      DELETE  
	ON emp
	FOR EACH ROW
  BEGIN
  dbms_output.put_line ( 'Trigger D' );
    CASE
      WHEN UPDATING THEN
      dbms_output.put_line ( 'Trigger D UPD' );
        if  :old.sal > :new.sal THEN
          RAISE_APPLICATION_ERROR (
             num=> -20107,
             msg=> 'Nie wooolno');
        END IF;
      WHEN DELETING THEN
      dbms_output.put_line ( 'Trigger D DEL' );
          RAISE_APPLICATION_ERROR (
             num=> -20107,
             msg=> 'Nie wooolno');
    END CASE;

dbms_output.put_line ( 'Trigger D END' );
	END D;
/

update emp set sal = 3000 where empno = 111; -- nie wolno
delete from emp where empno = 111;

